/**
 * app.js
 *
 */

/**
 * several useful objects declared here, used across app
 */

var classes = [];

var endpoint;

var queryAllClasses = "SELECT DISTINCT ?class ((count(?x)) AS ?cnt) WHERE { ?x a ?class .} GROUP BY ?class ORDER BY DESC(?cnt)";

var currentClass = -1;
var currentAttribute = -1;

var prefixIndex = 0;

var printedQuery;

var orderBy = [];

var graph = {
    nodes: [],
    edges: []
};

var query = {
    prefixes: [],
    variables: [],
    where: [],
    filters: [],
    aggregations: [],
    LIMIT: 0,
    OFFSET: 0,
    DISTINCT: true
};

var queryResults;


initialize();

/**
 * function initializes application - hides certain panels, prepares panel for SPARQL endpoint
 */
function initialize() {


    document.getElementById("messenger").style.display = "none";
    document.getElementById("container2").style.display = "none";
    document.getElementById("container3").style.display = "none";

    document.getElementById("input-attributes").value = "form:code,rdfs:label,URI";
    document.getElementById("input-languages").value = "cs,en,C";


    // get the name of used endpoint if we are in Sparkle
    if (typeof dataAgent != "undefined") {
        document.getElementById("endpoint").value = dataAgent.getStorageName();
    } else {
        document.getElementById("endpoint").value = "https://mre.zcu.cz/sparql";
    }

    document.getElementById("select-panel").style.display = "none";

    // handle sparql endpoint value submitted by user
    document.getElementById("connectButton").onclick = function () {

        var value = document.getElementById("endpoint").value;

        if (value === "") return;

        endpoint = value;

        // hide sparql endpoint panel
        document.getElementById("select-panel").style.display = "";
        document.getElementById("select-endpoint-panel").style.display = "none";
        document.getElementById("container2").style.display = "";
        document.getElementById("container3").style.display = "";

        // sparkle is capable of running the query
        if (typeof dataAgent != "undefined") {
            document.getElementById("results-panel").style.display = "none";
            document.getElementById("result-buttons").style.display = "none";
        }

        // start loading app up
        loadClasses();
    };
}
